<?php
if(!defined('MOD_ADMIN_PANEL')) {
	die;
}

class admin_plugin_bbtoolbar extends AdminPanelAction {
	/**
	 * This variable is the language location for the panel.
	 *
	 * @var string
	 */
	var $langres='plugin:bbtoolbar';

	/**
	 * This function sets the panel up.
	 */
	function setup() {
		$this->smarty->assign('admin_resource', 'plugin:bbtoolbar/admin.plugin.bbtoolbar');
	}

	/**
	 * This function is the main function.
	 * It just assigns to Smarty the type of captcha.
	 */
	function main() {
		$cwd=getcwd();
		chdir(dirname(__FILE__));
		$sets=glob('e_*');
		chdir($cwd);

		$this->smarty->assign('conf', $GLOBALS['plugin_bbtoolbar']->getConf(true, true));
		$this->smarty->assign('sets', $sets);
	}

	/**
	 * This function is called when the form is submitted.
	 *
	 * @return integer: The redirect option
	 */
	function onsubmit() {
		$options=array(
			'enEn'=>'en_en',
			'emEnTB'=>'em_en_tb',
			'emCoTB'=>'em_co_tb',
			'emEnP'=>'em_en_p',
			'emCoP'=>'em_co_p',
		);

		foreach($options as $opt=>$post) {
			plugin_addoption('bbtoolbar', $opt, isset($_POST[$post]));
		}

		plugin_addoption('bbtoolbar', 'emSet', $_POST['em_set']);
		$enCo=$_POST['en_co'];
		$enCo=$enCo!='auto' ? $enCo=='yes' : 'auto';
		plugin_addoption('bbtoolbar', 'enCo', $enCo);

		$save=$suc=plugin_saveoptions('bbtoolbar') ? 1 : -1;
		$this->smarty->assign('success', $suc);

		@unlink(BBTOOLBAR_CACHE);
		return 2;
	}
}

admin_addpanelaction('plugin', 'bbtoolbar', true);